****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for Fargo II : Level Definitions and Initialization          **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated April 16, 2000                            **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
****************************************************************************
****************************************************************************

******************************************** LIST OF LEVEL DATA TABLES
*
* I plan to change the design of the level loading system for the next
* version of the game.  As a result, I haven't written detailed comments
* for this file.
*
********

Level_Sets:
         dc.w     level_table_easy-Level_Sets
         dc.w     level_table_medium-Level_Sets
         dc.w     level_table_hard-Level_Sets
         dc.w     level_table_expert-Level_Sets

******************************************** LOAD NEXT LEVEL

Next_Level:
         clr.w    special_weapon_delay(a5)
         bsr      Status_Prepare

         move.l   level_pointer(a5),d0       ;Load level pointer
         move.l   d0,a0
         bne.s    not_init_time
         clr.w    level_number(a5)
         move.w   difficulty(a5),d0          ;If 0, load starting position
         add.w    d0,d0                      ;from level set tabl
         move.w   Level_Sets-2(pc,d0.w),d0
         lea      Level_Sets(pc,d0.w),a0
not_init_time:
         addq.w   #1,level_number(a5)
         move.w   (a0)+,d0                   ;Read level command
         move.l   a0,level_pointer(a5)       ;Store level pointer
         jmp      Level_Sets(pc,d0.w)

******************************************** LEVEL SEQUENCE CONTROL

L_RET    MACRO
         dc.w     Level_Return-Level_Sets
         ENDM

L_END    MACRO
         dc.w     Game_Finished-Level_Sets
         ENDM
         
L_EXEC   MACRO
         dc.w     \1-Level_Sets
         ENDM

L_CALL   MACRO
         dc.w     Level_Call-Level_Sets
         dc.w     \1-Level_Sets
         ENDM

Level_Call:
         subq.w   #1,level_number(a5)
         move.w   (a0)+,d0
         move.l   a0,level_stack(a5)
         lea      Level_Sets(pc,d0.w),a0
         bra.s    not_init_time

Level_Return:
         subq.w   #1,level_number(a5)
         move.l   level_stack(a5),a0
         bra.s    not_init_time

******************************************** LEVEL DATA

level_table_easy:
         L_CALL   First_Set
         L_CALL   Second_Set
         L_CALL   Third_Set
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_7_Standard
         L_EXEC   Level_8_Standard
         L_EXEC   Level_9_Boss
         L_CALL   Fifth_Set
         L_CALL   Sixth_Set
         L_CALL   Seventh_Set
         L_CALL   Super_Set
         L_EXEC   Level_25_SuperBoss
         L_EXEC   Free_Ship
         L_EXEC   Phoenix_Shop
         L_EXEC   Wheel_Loop_5
         L_EXEC   MWheel_Loop_8
         L_CALL   X_Set
         L_END

level_table_medium:
         L_CALL   First_Set
         L_CALL   Second_Set
         L_CALL   Third_Set
         L_CALL   Fourth_Set
         L_CALL   Fifth_Set
         L_CALL   Sixth_Set
         L_CALL   Seventh_Set
         L_CALL   Super_Set
         L_EXEC   Level_25_SuperBoss
         L_EXEC   Free_Ship
         L_EXEC   Phoenix_Shop
         L_EXEC   Wheel_Loop_5
         L_EXEC   Wheel_Loop_8
         L_EXEC   MWheel_Loop_10
         L_CALL   X_Set
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_26_Operators
         L_EXEC   Level_27_Operators_3Boss
         L_EXEC   Level_28_Operators_5Boss
         L_EXEC   Level_28_Operators_5Boss
         L_EXEC   Level_29_SuperBoss_Plus
         L_END

level_table_hard:
         L_CALL   First_Set
         L_CALL   Second_Set
         L_CALL   Third_Set
         L_CALL   Fourth_Set
         L_CALL   Fifth_Set
         L_CALL   Sixth_Set
         L_CALL   Seventh_Set
         L_CALL   Super_Set
         L_EXEC   Level_25_SuperBoss_Hard
         L_EXEC   Phoenix_Shop
         L_EXEC   Wheel_Loop_5
         L_EXEC   Wheel_Loop_8
         L_EXEC   Wheel_Loop_10
         L_EXEC   MWheel_Loop_15
         L_CALL   X_Set
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_26_Operators
         L_EXEC   Level_27_Operators_3Boss
         L_EXEC   Level_28_Operators_5Boss
         L_EXEC   Level_28_Operators_5Boss
         L_EXEC   Level_29_SuperBoss_Plus
         L_END

level_table_expert:
         L_CALL   First_Set
         L_CALL   Second_Set
         L_CALL   Third_Set
         L_CALL   Fourth_Set
         L_CALL   Fifth_Set
         L_CALL   Sixth_Set
         L_CALL   Seventh_Set
         L_CALL   Super_Set
         L_EXEC   Level_25_SuperBoss_Hard
         L_EXEC   Phoenix_Shop
         L_EXEC   Wheel_Loop_5
         L_EXEC   Wheel_Loop_8
         L_EXEC   Wheel_Loop_10
         L_EXEC   Wheel_Loop_16
         L_EXEC   MWheel_Loop_20
         L_CALL   X_Set
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_26_Operators
         L_EXEC   Level_27_Operators_3Boss
         L_EXEC   Level_28_Operators_5Boss
         L_EXEC   Level_28_Operators_5Boss
         L_EXEC   Level_29_SuperBoss_Plus
         L_EXEC   Level_29_SuperBoss_Plus
         L_END
         
First_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_1_Standard
         L_EXEC   Level_2_Standard
         L_EXEC   Level_3_Boss
         L_RET

Second_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_4_Standard
         L_EXEC   Level_5_Standard
         L_EXEC   Level_6_Boss
         L_EXEC   Triangles
         L_RET

Third_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_4a_Standard
         L_EXEC   Level_5a_Standard
         L_EXEC   Level_6a_Boss
         L_EXEC   Triangles
         L_RET

Fourth_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_7_Standard
         L_EXEC   Level_8_Standard
         L_EXEC   Level_9_Boss
         L_EXEC   Triangles
         L_RET

Fifth_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_10_Standard
         L_EXEC   Level_11_Standard
         L_EXEC   Level_12_2Boss
         L_RET

Sixth_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_13_Standard
         L_EXEC   Level_14_Standard
         L_EXEC   Level_15_3Boss
         L_RET

Seventh_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_16_Standard
         L_EXEC   Level_17_Standard
         L_EXEC   Level_18_Boss
         L_RET

Super_Set:
         L_EXEC   Phoenix_Shop
         L_EXEC   Level_19_Standard
         L_EXEC   Level_20_Standard
         L_EXEC   Level_21_3Boss
         L_RET

X_Set:   L_EXEC   Phoenix_Shop
         L_EXEC   Level_33_RandX
         L_EXEC   Level_34_RandX
         L_EXEC   Level_35_RandX
         L_RET

******************************************** LEVEL LOADERS

Level_1_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_1(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_2_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_1(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_3_Boss:
         lea      low_data_bank,a4
         lea      Enemy_1(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_4_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_2(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_1(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_5_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_2(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_6_Boss:
         lea      low_data_bank,a4
         lea      Enemy_2(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

get_enemy_3:
         cmp.w    #3,difficulty(a5)
         bge.s    get_tougher
         lea      Enemy_8(pc),a0
         rts
get_tougher:
         lea      Enemy_9(pc),a0
         rts

Level_4a_Standard:
         lea      standard_data_bank,a4
         bsr.s    get_enemy_3
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_1(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_5a_Standard:
         lea      swing_data_bank,a4
         bsr.s    get_enemy_3
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_6a_Boss:
         lea      low_data_bank,a4
         bsr.s    get_enemy_3
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_7_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_5(pc),a0
         lea      enemies_data(a5),a1
         moveq    #15,d0
         bra      Load_Enemy_Info

Level_8_Standard:
         lea      swing_data_bank_spread,a4
         lea      Enemy_5(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_9_Boss:
         lea      low_data_bank,a4
         lea      Enemy_5(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_10_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_3(pc),a0
         lea      enemies_data(a5),a1
         moveq    #15,d0
         bra      Load_Enemy_Info

Level_11_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_3(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_12_2Boss:
         lea      low_data_bank,a4
         lea      Enemy_3(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss1(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_13_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_4(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_3(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_14_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_4(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_15_3Boss:
         lea      low_data_bank,a4
         lea      Enemy_4(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-2(a1)
         move.w   #-270,-18(a1)
         rts

Level_16_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_6(pc),a0
         lea      enemies_data(a5),a1                   
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_17_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_6(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_18_Boss:
         lea      multi_data_bank,a4
         lea      Enemy_6(pc),a0
         lea      enemies_data(a5),a1
         moveq    #24,d0
         bsr      Load_Enemy_Info
         lea      E_Boss3(pc),a0
         moveq    #1,d0
         bra      Load_Enemy_Info

Level_19_Standard:
         lea      standard_data_bank,a4
         lea      Enemy_7(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      Enemy_3(pc),a0
         moveq    #10,d0
         bra      Load_Enemy_Info

Level_20_Standard:
         lea      swing_data_bank,a4
         lea      Enemy_7(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bra      Load_Enemy_Info

Level_21_3Boss:
         lea      low_data_bank,a4
         lea      Enemy_7(pc),a0
         lea      enemies_data(a5),a1
         moveq    #10,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-2(a1)
         move.w   #-270,-18(a1)
         rts

Level_25_SuperBoss_Hard:
         lea      enemies_data(a5),a1
         lea      low_data_bank,a4
         lea      Enemy_9(pc),a0
         moveq    #10,d0
         bsr      Load_Enemy_Info
         bra.s    Level_25_Common
Level_25_SuperBoss:
         lea      enemies_data(a5),a1
Level_25_Common:
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         subq.w   #1,enemies_remaining(a5)
         rts

Level_26_Operators:
         move.b   #64,smct+1
         lea      Enemy_0(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bra      Load_Enemy_Info

Level_27_Operators_3Boss:
         lea      Enemy_0(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-180,-2(a1)
         move.w   #-120,-18(a1)
         rts

Level_28_Operators_5Boss:
         lea      Enemy_0(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #5,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-2(a1)
         move.w   #-240,-18(a1)
         move.w   #-180,-34(a1)
         move.w   #-120,-50(a1)
         rts

Level_29_SuperBoss:
         lea      enemies_data(a5),a1
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR(pc),a0
L29_Common:
         moveq    #1,d0
         bsr      Load_Enemy_Info
         subq.w   #1,enemies_remaining(a5)
         lea      Enemy_0(pc),a0
         moveq    #22,d0
         bra      Load_Enemy_Info

Level_29_SuperBoss_Plus:
         lea      enemies_data(a5),a1
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL_(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR_(pc),a0
         bra.s    L29_Common

Level_33_RandX:
         move.b   #98,smct+1
         lea      E_X(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bra      Load_Enemy_Info

Level_34_RandX:
         lea      E_X(pc),a0
         lea      enemies_data(a5),a1
         moveq    #12,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #3,d0
         bsr      Load_Enemy_Info
         move.w   #-180,-2(a1)
         move.w   #-120,-18(a1)
         rts

Level_35_RandX:
         lea      E_X(pc),a0
         lea      enemies_data(a5),a1
         moveq    #20,d0
         bsr      Load_Enemy_Info
         lea      E_Boss2(pc),a0
         moveq    #5,d0
         bsr      Load_Enemy_Info
         move.w   #-210,-2(a1)
         move.w   #-240,-18(a1)
         move.w   #-120,-34(a1)
         move.w   #-180,-50(a1)
         rts

Level_36_RandX:
         lea      enemies_data(a5),a1
         lea      E_fake(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupL(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         lea      E_SupR(pc),a0
         moveq    #1,d0
         bsr      Load_Enemy_Info
         subq.w   #1,enemies_remaining(a5)
         lea      E_X(pc),a0
         moveq    #22,d0
         bra      Load_Enemy_Info

MWheel_Loop_20:
         moveq    #1,d0
         moveq    #20,d1
         moveq    #18,d2
         moveq    #40,d3
         moveq    #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

MWheel_Loop_15:
         moveq    #1,d0
         moveq    #15,d1
         moveq    #24,d2
         moveq    #40,d3
         moveq    #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

MWheel_Loop_10:
         moveq    #1,d0
         moveq    #10,d1
         moveq    #36,d2
         moveq    #40,d3
         moveq    #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

MWheel_Loop_8:
         moveq    #1,d0
         moveq    #8,d1
         moveq    #45,d2
         moveq    #40,d3
         moveq    #MWHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_16:
         moveq    #1,d0
         moveq    #16,d1
         moveq    #10,d2
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_10:
         moveq    #1,d0
         moveq    #10,d1
         moveq    #16,d2
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_8:
         moveq    #1,d0
         moveq    #8,d1
         moveq    #20,d2
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4
         bra.s    Wheel_Loader_Init

Wheel_Loop_5:
         moveq    #1,d0                      ; D0 = time counter
         moveq    #5,d1                      ; D1 = # enemies
         moveq    #32,d2                     ; D2 = staggering amount
         moveq    #40,d3
         moveq    #WHEEL_WAIT,d4

Wheel_Loader_Init:
         lea      enemies_data(a5),a1
         move.w   d1,enemies_remaining(a5)
         subq.w   #1,d1

Wheel_Loader:
         move.w   d4,(a1)+                   ; Initial type
         move.w   d3,(a1)+                   ; Enemy strength
         move.w   #-300,(a1)+                ; Dummy X-coord
         move.w   #15,(a1)+                  ; Width
         move.w   #-300,(A1)+                ; Dummy X-coord
         move.w   #15,(A1)+                  ; Height
         move.w   #in_Wheel_1,(a1)+          ; Image
         move.w   d0,(a1)+                   ; Time counter
         add.w    d2,d0                      ; Increment staggering level
         dbra     d1,Wheel_Loader
         rts

Triangles:
         move.w   level_number(a5),d0
         lea      enemies_data(a5),a1
         lea      E_Tri(pc),a0
         
******************************************** LEVEL LOADER SUBROUTINES

Load_Enemy_Info:
         move.l   a4,xy_pointer(a5)
         add.w    d0,enemies_remaining(a5)
         subq.w   #1,d0
_Load_Enemy_Info:
         lea      (a0),a2
         move.w   (a2)+,(a1)+
         move.w   (a2)+,(a1)+
         move.w   #-300,(a1)+
         move.w   (a2)+,(a1)+
         move.w   #-300,(a1)+
         move.w   (a2)+,(a1)+
         move.w   (a2)+,(a1)+
         move.w   (a2)+,(a1)+
         dbra     d0,_Load_Enemy_Info
         rts

******************************************** COORDINATE DATA BANKS

standard_data_bank:
         dc.w     70,20,90,20,110,20,130,20,150,20
         dc.w     70,35,90,35,110,35,130,35,150,35
         dc.w     70,50,90,50,110,50,130,50,150,50
         dc.w     70,65,90,65,110,65,130,65,150,65

swing_data_bank:
         dc.w     67,20,87,20,107,20,127,20,147,20
         dc.w     73,35,93,35,113,35,133,35,153,35
         dc.w     67,50,87,50,107,50,127,50,147,50
swing_data_bank_spread:
         dc.w     73,65,93,65,113,65,133,65,153,65
         dc.w     63,20,83,20,103,20,123,20,143,20
         dc.w     73,35,93,35,113,35,133,35,153,35
         dc.w     63,50,83,50,103,50,123,50,143,50

low_data_bank:
         dc.w     70,54,90,54,110,54,130,54,150,54
         dc.w     70,69,90,69,110,69,130,69,150,69      

multi_data_bank:
         dc.w     64,52,76,52,88,52,100,52,112,52,124,52,136,52,148,52
         dc.w     64,61,76,61,88,61,100,61,112,61,124,61,136,61,148,61
         dc.w     64,70,76,70,88,70,100,70,112,70,124,70,136,70,148,70

******************************************** ENEMY DATA BLOCKS

         ;type, strength, width, height, image, data

Enemy_1: dc.w     2,2,8,7,in_Enemy_1,-1      ; First normal enemy
Enemy_2: dc.w     2,4,11,8,in_Enemy_2,-1     ; Second nomral enemy
Enemy_3: dc.w     8,8,10,10,in_Enemy3_1,-1   ; Spinning enemy
Enemy_4: dc.w     10,12,10,10,in_Enemy4_1,-1 ; Tough spinning enemy
Enemy_5: dc.w     12,6,7,13,in_Enemy_5,-1    ; Tall arrow-launching enemy
Enemy_6: dc.w     14,16,7,7,in_Enemy_6,-1    ; Tough X enemy
Enemy_7: dc.w     16,20,10,10,in_Enemy7_1,-1 ; Super-tough spinning enemy
Enemy_8: dc.w     2,6,6,5,in_Enemy_8,-1      ; Third nomral enemy
Enemy_9: dc.w     36,6,6,5,in_Enemy_8,-1     ; Third nomral enemy (tougher)
Enemy_0: dc.w     26,30,7,7,in_Enemy_0_5,-1  ; OPERATOR!

E_Tri:   dc.w     32,16,13,11,in_Triangle,$101
E_X:     dc.w     34,24,9,7,in_E_X,$101

E_Boss1: dc.w     4,40,17,14,in_Boss_1,-90   ; Standard boss
E_Boss2: dc.w     4,50,17,14,in_Boss_2,-150  ; Second (fuzzy center) boss
E_Boss3: dc.w     4,100,17,9,in_Boss_X,-100  ; Double-X Boss

E_SupL:  dc.w     18,150,17,11,in_SuperBoss_Left,-5
E_SupR:  dc.w     20,150,17,11,in_SuperBoss_Right,-5
E_SupL_: dc.w     18,250,17,15,in_SuperBoss_Left_,-5
E_SupR_: dc.w     20,250,17,15,in_SuperBoss_Right_,-5

E_fake:  dc.w     22,32767,1,1,in_fake,-5    ; Fake enemy for attaching
