****************************************************************************
****************************************************************************
**                                                                        **
**   Phoenix for TI-89, TI-92, and TI-92 Plus : Basic Support Routines    **
**                                                                        **
**   Copyright 1997-2000 by Patrick Davidson.  All Rights Reserved.       **
**                                                                        **
**   This file was last updated April 7, 2000                             **
**                                                                        **
**   For complete copyright information and contact addresses, refer to   **
**   the main source file "PHOENIX.ASM"                                   **
**                                                                        **
*********************fs*******************************************************
****************************************************************************

******************************************** TI-OS KEYBOARD READING

Get_Key:
         lea      tios::kb_vars+$1c,a3
         tst.w    (a3)                       ; See if a keypress is stored
         beq.s    Get_Key                    ; Continue waiting if not
         clr.w    (a3)                       ; Clear keypress counter
         move.w   2(a3),d0                   ; Read keypress
         rts

Test_Key:
         lea      tios::kb_vars+$1c,a3
         tst.w    (a3)
         beq.s    no_key
         clr.w    (a3)
         move.w   2(a3),d0
         rts
no_key:
         moveq    #0,d0
         rts

      IFD ti89
wait_keyport:
         moveq    #20,d1                     ; Increase this if there are
loop_keywait:                                ; keyboard reading errors.
         dbra     d1,loop_keywait
         rts
      ENDIF
         
******************************************** BASIC DISPLAY ROUTINES

Set_Font:                                    ; Set font to D0
         move.w   d0,-(sp)
         jsr      tios::FontSetSys
         addq.w   #2,sp
         rts

Display_String:                              ; Display (A0) at (D1,D0)
         move.w   #4,-(sp)     
         move.l   a0,-(sp)
         move.w   d0,-(sp)
         move.w   d1,-(sp)
         jsr      tios::DrawStrXY
         
         lea      10(sp),sp
         rts

******************************************** RANDOM-NUMBER GENERATOR

random:                                      ; based on flib random
         move.l   d1,-(sp)
         move.w   #0,d1
	mulu.w	#31421,d1
	add.w	#6927,d1
	mulu.w	d1,d0
         move.w   d1,random+4
	clr.w	d0
	swap	d0
	move.l	(sp)+,d1
	rts
